var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { Injectable, Inject } from '@angular/core';
import { Location } from '@angular/common';
import { SANDBOXES } from './tokens';
export var UrlService = (function () {
    function UrlService(sandboxes, location) {
        this.sandboxes = sandboxes;
        this.location = location;
        this._embed = null;
        this._select = null;
        var urlPath = location.path();
        this._embed = /[?|&]embed=1/.exec(urlPath) !== null;
        this._select = this.parse('scenario', sandboxes, urlPath);
    }
    Object.defineProperty(UrlService.prototype, "embed", {
        get: function () {
            return this._embed;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UrlService.prototype, "select", {
        get: function () {
            return this._select;
        },
        enumerable: true,
        configurable: true
    });
    UrlService.prototype.setSelected = function (sandboxKey, scenarioKey) {
        if (sandboxKey === null && scenarioKey === null) {
            this.location.replaceState('');
            return;
        }
        var scenarioDescription = this.sandboxes
            .find(function (sandbox) { return sandbox.key.toLowerCase() === sandboxKey.toLowerCase(); })
            .scenarios.find(function (scenario) { return scenario.key === scenarioKey; }).description;
        this.location.replaceState("?scenario=" + encodeURIComponent(sandboxKey) + "/" + encodeURIComponent(scenarioDescription));
    };
    UrlService.prototype.parse = function (key, sandboxes, urlPath) {
        var match = new RegExp('[?|&]' + key + '=([^&#]*)').exec(urlPath);
        if (match !== null) {
            var value_1 = decodeURIComponent(match[1]);
            var firstSlash_1 = value_1.indexOf('/');
            var filter = value_1.substr(0, firstSlash_1);
            var sandboxKey_1 = filter;
            var scenarioKey = sandboxes
                .find(function (sandbox) { return sandbox.key.toLowerCase() === sandboxKey_1.toLowerCase(); })
                .scenarios.findIndex(function (scenario) { return scenario.description.toLowerCase() === value_1.substr(firstSlash_1 + 1, value_1.length).toLowerCase(); }) + 1;
            return { filter: filter, sandboxKey: sandboxKey_1, scenarioKey: scenarioKey };
        }
    };
    UrlService = __decorate([
        Injectable(),
        __param(0, Inject(SANDBOXES)), 
        __metadata('design:paramtypes', [Array, Location])
    ], UrlService);
    return UrlService;
}());
